/*
    FEARLUS model0-7-1: Spatial.h
    Copyright (C) 1999-2003, 2006  Macaulay Institute

    This file is part of FEARLUS model0-7-1, an agent-based model of land use
    change.

    FEARLUS model0-7-1 is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FEARLUS model0-7-1 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details. (LICENCE file in
    this directory.)

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact information:
      Gary Polhill,
      Macaulay Institute, Craigiebuckler, Aberdeen, AB15 8QH. United Kingdom
      g.polhill@macaulay.ac.uk
*/
/*
Spatial protocol. Objects that are spatial follow this protocol. They can
either be Grid2DSpatial, in which case they must implement getX and getY,
or LogicallySpatial, in which case they must implement some other method I
haven't decided yet...

*/

@protocol Spatial

@end

@protocol Grid2DSpatial <Spatial>

-(int)getX;
-(int)getY;

@end

@protocol LogicallySpatial <Spatial>

/*

Methods for non-grid-based accessing of relative neighbourhoods

*/

@end
